unit Unit2;

interface
uses SysUtils;
type
  EInvalidOperand = class(EMathError);

  TOperand = class
    public
     function plus(val:TOperand):TOperand;virtual;abstract;
     function times(val:TOperand):TOperand;virtual;abstract;
  end;

  TCele = class (TOperand)
   private
    val:integer;
   public
    constructor init(val:integer);
    function plus(val:TOperand):TOperand;override;
    function times(val:TOperand):TOperand;override;
    function getValue:integer;
  end;

  TKomplexni = class (TOperand)
   private
    re,im:real;
   public
    constructor init(real,im:real);
    function plus(val:TOperand):TOperand;override;
    function times(val:TOperand):TOperand;override;
    function getReal:real;
    function getIm:real;
  end;
implementation

  constructor TCele.init(val:integer);
  begin
   self.val := val;
  end;

  constructor TKomplexni.init(real,im:real);
  begin
   self.re := real;
   self.im := im;
  end;

  function TCele.plus(val:TOperand):TOperand;
  var pom:TCele;
  begin
   if(val is TCele) then
     begin
       pom:=val as TCele;
       plus:=TCele.init(pom.getValue + self.val);
     end
   else raise EInvalidOperand.Create('Operand neni cele cislo');
  end;

  function TCele.times(val:TOperand):TOperand;
  var pom:TCele;
  begin
   if(val is TCele) then
     begin
       pom:=val as TCele;
       times:= TCele.init(pom.getValue * self.val);
     end
   else raise EInvalidOperand.Create('Operand neni cele cislo');

  end;

  function TCele.getValue:integer;
  begin
   getValue := val;
  end;

  function TKomplexni.plus(val:TOperand):TOperand;
  var pom: TKomplexni;
  begin
    if(val is TKomplexni) then
       begin
         pom:=val as TKomplexni;
         plus:=TKomplexni.init(pom.getReal + self.re, pom.getIm + self.im);
       end
     else raise EInvalidOperand.Create('Operand neni komplexni cislo');
  end;

  function TKomplexni.times(val:TOperand):TOperand;
  var rr:real;
     rIm:real;
   pom:TKomplexni;

  begin
    if(val is TKomplexni) then
       begin
         pom:=val as TKomplexni;
         rr := self.re * pom.getReal - self.im * pom.getIm;
         rIm := self.re * pom.getIm + self.im * pom.getReal;
         times:=TKomplexni.init(rr,rIm);
       end
     else raise EInvalidOperand.Create('Operand neni komplexni cislo');
  end;

  function TKomplexni.getReal:real;
  begin
   getReal := re;
  end;

  function TKomplexni.getIm:real;
  begin
   getIm :=im;
  end;

end.
